<?php

namespace IMATHUZH\Qfq\Core\Renderer\FormElement\Bootstrap3;

use IMATHUZH\Qfq\Core\Form\FormElement\AbstractFormElement;
use IMATHUZH\Qfq\Core\Helper\HelperFormElement;
use IMATHUZH\Qfq\Core\Helper\Support;
use IMATHUZH\Qfq\Core\Renderer\FormElement\Base\SelectRenderer;

class Bootstrap3SelectRenderer extends SelectRenderer
{
    public function renderInput(AbstractFormElement $fe, string $renderMode = RENDER_MODE_HTML) : string
    {
        $option = '';
        $firstSelect = true;
        $jsonValues = array();
        $total = count($fe->itemValues);
        for ($ii = 0; $ii < $total; $ii++) {
            $option .= '<option ';

            $option .= Support::doAttribute('value', $fe->itemKeys[$ii], false);

            if ($ii == 0 && $fe->attributes[FE_PLACEHOLDER] != '') {
                $option .= 'disabled hidden ';
            }

            $jsonValues[] = [
                'value' => $fe->itemKeys[$ii],
                'text' => $fe->itemValues[$ii],
                'selected' => ($fe->itemKeys[$ii] == $fe->value && $firstSelect),
            ];

            if ($fe->itemKeys[$ii] == $fe->value && $firstSelect) {
                $option .= 'selected';
                $firstSelect = false;
            }

            $option .= '>' . $fe->itemValues[$ii] . '</option>';
        }

        //$wrapSetupClass = $this->wrap[WRAP_SETUP_ELEMENT][WRAP_SETUP_CLASS] ?? '';
        //$json = $this->getFormElementForJson($htmlFormElementName, $jsonValues, $formElement, $wrapSetupClass);

        $fe->attributes = HelperFormElement::prepareExtraButton($fe->attributes, false);
        if (isset($fe->attributes["datalist"])) {
            if ($fe->attributes[FE_DYNAMIC_UPDATE] === 'yes') {
                throw new \UserFormException("Datalist and dynamic update are not compatible", ERROR_NOT_IMPLEMENTED);
            }
            $fe->htmlAttributes['list'] = $fe->attributes[FE_HTML_ID] . '-datalist';
            $html = '<input ' . Support::arrayToXMLAttributes($fe->htmlAttributes) . '><datalist '
                . Support::doAttribute('id', $fe->htmlAttributes['list']) . '>' . $option . '</datalist>';
        } else {
            $html = '<select class="form-control" ' . Support::arrayToXMLAttributes($fe->htmlAttributes) . '>' . $option . '</select>';
        }
        $html = $html . HelperFormElement::getHelpBlock() . $fe->attributes[FE_TMP_EXTRA_BUTTON_HTML];
        return $html . $fe->attributes[FE_INPUT_EXTRA_BUTTON_INFO];

    }
}